=== modified file 'src/com/goldencode/p2j/ui/client/gui/WindowGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/WindowGuiImpl.java	2022-02-15 12:19:45 +0000
+++ src/com/goldencode/p2j/ui/client/gui/WindowGuiImpl.java	2022-03-06 21:49:25 +0000
@@ -202,6 +202,9 @@
 **     VVT 20220202 findMouseSource(MouseEvt) removed. See #6013.
 **     VVT 20220215 Change 13474 for #6013 temporary reverted (caused multiple regressions,
 **                  need to be completed).
+**     VVT 20220306 1) findMouseSource(MouseEvent) moved to TopLevelWindow. 2) init(): now that true
+**                  mouse source is WindowTitle calculated instead of WindowTitleBar, WindowTitle
+**                  is registered with gd.registerMoveableWidget instead of WindowTitleBar.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -309,7 +312,7 @@
    /** The physical window height, after resize. */
    private int resizedHeight;
 
-   /** The last mouse pressed determined for this window. */
+   /** The last mouse pressed widget in this window. This field is set when mouse is pressed. */
    private Widget<GuiOutputManager> mousePressedSource = null;
    
    /** The location before the window is maximized or minimized. */
@@ -873,53 +876,6 @@
    }
    
    /**
-    * Find the widget to which the given mouse event can be applied.
-    * 
-    * @param    evt
-    *           The mouse event.
-    * 
-    * @return   A widget over which the mouse is positioned or {@code null} if none found.
-    */
-   @Override
-   public Widget<GuiOutputManager> findMouseSource(MouseEvt evt)
-   {
-      Widget<GuiOutputManager> widget = null;
-      
-      int evtID = evt.getEvent().getID();
-      
-      if (evtID == MouseEvent.MOUSE_DRAGGED  || 
-          evtID == MouseEvent.MOUSE_RELEASED || 
-          evtID == MouseEvent.MOUSE_CLICKED)
-      {
-         return mousePressedSource;
-      }
-      
-      try
-      {
-         java.awt.Point p = evt.getEvent().getPoint();
-         
-         // search the other widgets
-         widget = findMouseSource(new NativePoint(p.x, p.y));
-         
-         widget = (widget == null ? this : widget);
-      }
-      finally
-      {
-         if (widget != null && evtID == MouseEvent.MOUSE_PRESSED)
-         {
-            mousePressedSource = widget;
-         }
-         
-         if (evtID == MouseEvent.MOUSE_CLICKED)
-         {
-            mousePressedSource = null;
-         }
-      }
-      
-      return widget;
-   }
-   
-   /**
     * Iconify the window.
     * 
     * @param   postEvent
@@ -2089,7 +2045,7 @@
       // can be missing if there are no decorations
       if (hasTitlebar())
       {
-         gd.registerMoveableWidget(titleBar.getId().asInt());
+         gd.registerMoveableWidget(titleBar.title.getId().asInt());
       }
       gd.registerResizeableWidget(contentPane.getId().asInt());
       

=== modified file 'src/com/goldencode/p2j/ui/client/gui/WindowTitleBar.java'
--- src/com/goldencode/p2j/ui/client/gui/WindowTitleBar.java	2021-08-10 18:30:38 +0000
+++ src/com/goldencode/p2j/ui/client/gui/WindowTitleBar.java	2022-03-06 21:49:25 +0000
@@ -2,7 +2,7 @@
 ** Module   : WindowTitleBar.java
 ** Abstract : GUI window title bar implementation
 **
-** Copyright (c) 2014-2021, Golden Code Development Corporation.
+** Copyright (c) 2014-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description----------------------------------
 ** 001 CA  20140805 Created initial version.
@@ -78,6 +78,17 @@
 **     CA  20201117 Fixed a leak for the caption buttons, which need to be deleted explicitly. 
 **     VVT 20210810 AbstractGuiDriver.createIcon(..) method made static: the method does not depend on
 **                  the kind of the driver.
+**     VVT 20220306 1) unused import statemet removed
+**                  2) duplicate interfaces removed from the class definition
+**                  3) The allButtons field made constant (final).
+**                  4) The class fixed in static method call: TopLevelWindow.getWindowDefaultIcon() (was Window).
+**                  5) Missing @Override annotations were added
+**                  6) toString 8 lines of code refactored to 1.
+**                  7) loadIcon method: access to a closable resource surrounded by try/catch block.
+**                  8) Internal WindowTitle class access restriction weakened to allow access from outside
+**                  of this class
+**                  9) Overridden findMouseSource(int eventId, NativePoint p) introduced in the previous
+**                  release was removed: special treatment is no more needed for this container widget children.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -143,7 +154,6 @@
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.*;
-import com.goldencode.p2j.ui.client.ClientDrivenLabel;
 import com.goldencode.p2j.ui.client.event.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
 import com.goldencode.p2j.ui.client.gui.theme.*;
@@ -160,9 +170,7 @@
  */
 public class WindowTitleBar
 extends AbstractContainer<GuiOutputManager>
-implements WidgetWithConfig<BaseConfig>,
-           MouseListener,
-           MouseMotionListener
+implements WidgetWithConfig<BaseConfig>
 {
    /** The window's icon. */
    WindowIcon icon;
@@ -174,7 +182,7 @@
    private GuiDriver gd;
 
    /** The full set of window caption buttons */
-   private CaptionButton[] allButtons;
+   private final CaptionButton[] allButtons;
 
    /** The displayed caption buttons. */
    private CaptionButton[] buttons;
@@ -239,7 +247,7 @@
       icon = new WindowIcon(WidgetId.nextID());
       icon.setHidden(!showWindowIcon);
 
-      byte[] appIcon = Window.getWindowDefaultIcon();
+      byte[] appIcon = TopLevelWindow.getWindowDefaultIcon();
 
       // found the application icon defined on the server side
       if (appIcon != null)
@@ -313,6 +321,7 @@
    /**
     * Layout the elements of this title.   Everything is done in pixel units.
     */
+   @Override
    public void doLayout()
    {
       double height = ThemeManager.getCurrentTheme().layoutTitleBar(
@@ -650,14 +659,7 @@
       String parent = super.toString();
       // topLevelWindow() will throw exception instead of returning null 
       TopLevelWindow tlw = parentOrSelf(TopLevelWindow.class);
-      if (tlw != null)
-      {
-         return parent + " [window=" + tlw + "]";
-      }
-      else
-      {
-         return parent;
-      }
+      return (tlw != null) ? parent + " [window=" + tlw + "]" : parent;
    }
 
    /**
@@ -678,7 +680,6 @@
     */
    class WindowIcon
    extends ImageGuiImpl
-   implements MouseListener
    {
       /** Flag indicating the icon was loaded by LOAD-SMALL-ICON(). */
       private boolean useSmallIconSize = false;
@@ -796,36 +797,27 @@
        * @return   <code>TRUE</code> if operation successful <code>FALSE</code> otherwise.
        */
       public boolean loadIcon(boolean small, String name)
-      {
-         InputStream is = null;
-         byte[] icon = null;
-         
+      {         
          // find the icon on local file system
-         try
-         {
-            is = new FileInputStream(name);
-         }
-         catch (FileNotFoundException ex)
-         {
-            is = null;
-         }
-         
-         // the file is found, try to read
-         if (is != null)
-         {
-            icon = UiUtils.getData(is);
-         }
-         
-         // if having new icon data - set it
-         if (icon != null)
-         {
-            useSmallIconSize = small;
-            return setIconData(icon);
-         }
-         else
-         {
-            return false;
-         }
+         try(InputStream is = new FileInputStream(name))
+         {
+            final byte[] icon = UiUtils.getData(is);
+
+            // if having new icon data - set it
+            if (icon != null)
+            {
+               useSmallIconSize = small;
+               return setIconData(icon);
+            }
+            
+         }
+         catch (IOException e)
+         {
+            LOG.warning("Cannot load icon: " + name + ": " + e.getMessage());
+         }
+         
+         return false;
+         
       }
 
       /**
@@ -888,7 +880,7 @@
    /**
     * The window's title.
     */
-   private class WindowTitle
+   class WindowTitle
    extends ClientDrivenLabel<GuiOutputManager>
    {
       /** The cached window title */
@@ -1003,6 +995,23 @@
       }
 
       /**
+       * Find the source for mouse event.
+       * 
+       * @param eventId
+       *        the event ID to match 
+       * @param p
+       *        the mouse position relative to this widget
+       *        
+       * @return the mouse event source or {@code null} if no source found.
+       */
+      @Override
+      public Widget<GuiOutputManager> findMouseSource(int eventId, NativePoint p)
+      {
+         Widget<GuiOutputManager> w = super.findMouseSource(eventId, p);
+         return (w != null ? w : this);
+      }
+
+      /**
        * Retrieve the widget's width in native units.
        * 
        * @return   See above.
@@ -1023,5 +1032,7 @@
       {
          return screen().coordinates().heightToNative(height());
       }
+
    }
+
 }

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/MouseDirectManipulation.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/MouseDirectManipulation.java	2022-02-15 17:19:54 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/MouseDirectManipulation.java	2022-03-06 21:49:25 +0000
@@ -26,6 +26,21 @@
 **                  has custom pointer defined.
 **     VVT 20220215 Wrong Javascript comments fixed and some other minor changes. 3 unused private
 **                  methods commented as such.
+**     VVT 20220306 1) processDrag(MouseEvent, boolean): unused second argument removed.
+**                  2) Unused selectSingleWidget(false) removed
+**                  3) selectSingleWidget(boolean): method argument inlined and removed (always true),
+**                  assertion added to check this widget is selected at the moment of the call.
+**                  4) Unused private method removed: deselectEverythingExcept(Widget)
+**                  5) Methods deselectFrameWidgets(Frame) deselectFrameWidgetsExcept(Frame, Widget)
+**                  refactored
+**                  into one deselectFrameWidgets(Frame) (the second "except" parameter is not used anymore).
+**                  6) Unused private method deselectEverythingExcept(Widget) removed.
+**                  7) Private method deselectEverything() inlined (only single use).
+**                  8) Unused private methods deselectNestedFrames(Frame), deselectNestedFramesExcept(Frame)
+**                  removed.
+**                  9) mousePressed refactored: if (!widgetResizing) replaced by more meaningful if
+**                  (rowResizing); if/else replaced by early return; two conditional block with
+**                  !isExtended(e) as part of condition replaced by one block.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -196,6 +211,9 @@
    /** The widget's custom mouse pointer (if any). */
    private MousePtrWrapper mousePtr = null;
    
+   /** The widget mouse was pressed upon. */
+   private Widget mousePressedSource;
+   
    /**
     * Constructor.
     * 
@@ -264,7 +282,7 @@
 
       if (isDirectManipulationValid())
       {
-         processDrag(e, !dragInProgress);
+         processDrag(e);
       }
    }
 
@@ -364,7 +382,7 @@
             // post the event to target widget if not already selected
             if (!((BaseConfig)widgetEff.config()).selected)
             {
-               selectSingleWidget(true);
+               selectSingleWidget();
             }
          }
       }
@@ -384,58 +402,61 @@
          return;
       }
       
+      mousePressedSource = widgetEff;
+      
       mousePtr = widget.getCustomMousePointer().orElse(null);
 
       // reset NO-APPLY cache
       eventNoApply = -1;
       startPoint = ((AbstractWidget)widget).translate(e);
-      // prepare mouse coord to resize operation check 
+      // prepare mouse coordinates to resize operation check 
       NativePoint resizePoint = ((Frame)parentContainer).getContentPane().translate(e);
       widgetResizing = isInsideFrameResizeHandle(resizePoint) ||
                        isInsideResizeHandle(resizePoint);
       // widget resizing has higher priority comparing to widgets moving
-      if (!widgetResizing)
-      {
-         rowResizing = isInsideRowResizable() && isInsideRowResizeArea(e);
-         
-         if (rowResizing)
-         {
-            // start browse widget row resize mode
-            EventManager.postEvent(new DirectManipulationEvent(
-                                                     ((BrowseColumnGuiImpl)widgetEff).getBrowse(),
-                                                                   Keyboard.SE_START_ROW_RESIZE));
-         }
-         else
-         {
-            // defer start moving to mouseDrag() first event
-            if (!((BaseConfig)widgetEff.config()).selected && !isExtended(e))
-            {
-               if (isFrame)
-               {
-                  // empty selection event before every child widget is deselected
-                  // ant the target frame is selected
-                  EventManager.postEvent(new DirectManipulationEvent(widgetEff,
-                                                                     Keyboard.SE_EMPTY_SELECTION));
-               }
-               selectSingleWidget(true);
-            }
-            else if (isFrame && !isExtended(e))
-            {               
-               // the target widget is an already selected frame: do not deselect child widgets
-               
-               if (((PaneConfig)widgetEff.config()).boxSelectable)
-               {
-                  // we will enter box selecting mode if drag next
-                  boxSelecting = true;
-               }
-            }
-         }
-      }
-      else
+      if (widgetResizing)
       {
          // start widget resizing mode
          EventManager.postEvent(new DirectManipulationEvent(this, widgetToResize,
                                                             Keyboard.SE_START_RESIZE));
+         return;
+      }
+      
+      rowResizing = isInsideRowResizable() && isInsideRowResizeArea(e);
+
+      if (rowResizing)
+      {
+         // start browse widget row resize mode
+         EventManager.postEvent(new DirectManipulationEvent(
+                  ((BrowseColumnGuiImpl) widgetEff).getBrowse(), Keyboard.SE_START_ROW_RESIZE));
+         return;
+      }
+      
+      if (!isExtended(e))
+      {
+         // defer start moving to mouseDrag() first event
+         WidgetConfig config = widgetEff.config();
+         if (!((BaseConfig) config).selected)
+         {
+            if (isFrame)
+            {
+               // empty selection event before every child widget is deselected
+               // and the target frame is selected
+               EventManager.postEvent(
+                        new DirectManipulationEvent(widgetEff, Keyboard.SE_EMPTY_SELECTION));
+            }
+
+            selectSingleWidget();
+            
+            return;
+         }
+
+         // the target widget is an already selected frame: do not deselect child widgets
+         if (isFrame && (((PaneConfig) config).boxSelectable))
+         {
+            // we will enter box selecting mode if drag next
+            boxSelecting = true;
+         }
       }
    }
 
@@ -638,9 +659,9 @@
                                                                           Keyboard.SE_END_MOVE);
 
             // set up move shift taking into account possible grid snap flag
-            NativePoint newP = null;
             NativePoint currLoc = widMove[i].physicalLocation();
 
+            NativePoint newP;
             if (isGridSnapOn())
             {
                newP = new NativePoint(alignToGrid(currLoc.x + xMove, false),
@@ -667,9 +688,13 @@
          // clean up previous drawings
          drawMovableWidgetsBounds(xOld, yOld, true);
       }
+      
+      // FIXME vvt check if the following still make sense:
+      
       // for some reasons web client driver unlike swing one generates click even for
-      // pres-drag-release sequence so we disable click handling here for drag operations
+      // press-drag-release sequence so we disable click handling here for drag operations
       clickExpected = !dragInProgress;
+      
       // clean up all mode flags
       startPoint = null;
       boxSelecting = false;
@@ -677,6 +702,8 @@
       widgetResizing = false;
       rowResizing = false;
       widgetToResize = null;
+      mousePressedSource = null;
+
       if (dragInProgress)
       {
          // finish any selection box paintings
@@ -706,10 +733,8 @@
     * 
     * @param    evt
     *           The mouse event details.
-    * @param    firstCall
-    *           Flag indicating first call in a current drag session.
     */
-   public void processDrag(MouseEvent evt, boolean firstCall)
+   protected void processDrag(MouseEvent evt)
    {
       // possible issue here, drag was started somewhere else or other error
       if (startPoint == null)
@@ -854,9 +879,12 @@
          yOld = y;
          wOld = w;
          hOld = h;
+         
+         return;
       }
+      
       // then row resizing
-      else if (rowResizing && eventNoApply != Keyboard.SE_START_ROW_RESIZE)
+      if (rowResizing && eventNoApply != Keyboard.SE_START_ROW_RESIZE)
       {
          // get the main browse widget
          BrowseGuiImpl br = ((BrowseColumnGuiImpl) widgetEff).getBrowse();
@@ -897,29 +925,36 @@
          // save parameters for resizing complete
          yOld = y;
          hOld = h;
+         
+         return;
       }
+      
       // then widgets moving
-      else if (widgetsMoving && eventNoApply != Keyboard.SE_START_MOVE)
+      if (widgetsMoving && eventNoApply != Keyboard.SE_START_MOVE)
       {
+         // clean up previous drawings
+         if (dragInProgress)
+         {
+            drawMovableWidgetsBounds(xOld, yOld, true);
+         }
+         else
+         {
+            dragInProgress = true;
+         }
+
          // new move distance
          int xShift = n.x - startPoint.x;
          int yShift = n.y - startPoint.y;
-         // clean up previous drawings
-         if (dragInProgress)
-         {
-            drawMovableWidgetsBounds(xOld, yOld, true);
-         }
-         else
-         {
-            dragInProgress = true;
-         }
          // draw new bounds
          drawMovableWidgetsBounds(xShift, yShift, false);
          xOld = xShift;
          yOld = yShift;
+         
+         return;
       }
+      
       // drag in a frame enters box selection mode
-      else if (boxSelecting && eventNoApply != Keyboard.SE_START_BOX_SELECTION)
+      if (boxSelecting && eventNoApply != Keyboard.SE_START_BOX_SELECTION)
       {
          // calculate rectangle parameters
          int x = n.x < startPoint.x ? n.x : startPoint.x;
@@ -1027,7 +1062,7 @@
       // get rectangles for movable widgets
       NativeRectangle [] nrMovable = getMovableWidgetsBounds();
       // draw rectangles for movable widgets
-      if (nrMovable != null && nrMovable.length > 0)
+      if (nrMovable != null)
       {
          for (NativeRectangle nr : nrMovable)
          {
@@ -1077,7 +1112,7 @@
          return point;
       }
 
-      Container parent = null;
+      Container parent;
 
       if (isFrame)
       {
@@ -1089,6 +1124,7 @@
       }
 
       NativeDimension parentDim = parent.physicalDimension();
+      
       int newx = Math.min(parentDim.width - widgetDim.width, point.x);
       int newy = Math.min(parentDim.height - widgetDim.height, point.y);
       newx = Math.max(0, newx);
@@ -1193,10 +1229,6 @@
     */
    private boolean isInsideFrameResizeHandle(NativePoint np)
    {
-      // need a little fix to take into account frame title height
-      NativePoint npCheck = new NativePoint(np);
-      npCheck.y += ((FrameGuiImpl)parentContainer).getTitleHeight();
-      
       // check the frame itself first
       BaseConfig fc = parentContainer.config();
       if (fc.selected && fc.resizable)
@@ -1204,6 +1236,11 @@
          // generate resize handles coordinates for current widget
          NativeRectangle[] frResizeHandles = getFrameResizeHandles(parentContainer);
          // check if we are inside one of them
+
+         // need a little fix to take into account frame title height
+         NativePoint npCheck = new NativePoint(np);
+         npCheck.y += ((FrameGuiImpl)parentContainer).getTitleHeight();
+         
          for(int i = 0; i < frResizeHandles.length; i++)
          {
             if (frResizeHandles[i].contains(npCheck))
@@ -1252,11 +1289,9 @@
                                                                                       rowNum;
          return true;
       }
-      else
-      {
-         resizeDirection = RESIZE_DIRECTION_UNDEF;
-         return false;
-      }
+      
+      resizeDirection = RESIZE_DIRECTION_UNDEF;
+      return false;
    }
 
    /**
@@ -1274,145 +1309,66 @@
    /**
     * Selects single widget the current handler is attached to.  All other selected widget inside
     * current container will be de-selected, including container itself.
-    *        
-    * FIXME: this private method is never used and should probably be removed.
+    * 
+    * The widget is supposed to be unselected at the moment of the call.
     */
    private void selectSingleWidget()
    {
-      selectSingleWidget(false);
-   }
-   
-   /**
-    * Selects single widget the current handler is attached to.  All other selected widget inside
-    * current container will be de-selected, including container itself.
-    * 
-    * @param    repaintParent
-    *           If <code>TRUE</code> the parent repaint should be performed after message
-    *           processing.
-    */
-   private void selectSingleWidget(boolean repaintParent)
-   {
+      assert !((BaseConfig) widgetEff.config()).selected;
+
       // deselect everything selected
-      deselectEverything();
-      // select single widget
-      EventManager.postEvent(new DirectManipulationEvent(widgetEff, parentContainer,
-                                                         repaintParent, Keyboard.SE_SELECTION));
-   }
-   
-   /**
-    * Deselect all selected widget inside the current container, including container itself.
-    * If nested frames deselect parent frame widgets as well. 
-    * 
-    * @param   except
-    *          A widget to be skipped by the deselection. This can be {@code null}.
-    */
-   private void deselectEverythingExcept(Widget<?> except)
-   {
       if (parentContainer != null)
       {
-         // first deselect the parent frame if nested;
-         deselectNestedFramesExcept((Frame<?>) parentContainer, except);
-         // then the frame itself
-         BaseConfig fc = parentContainer.config();
-         if (fc.selectable && fc.selected && parentContainer != except)
-         {
-            EventManager.postEvent(new DirectManipulationEvent(parentContainer, parentContainer,
-                                                               Keyboard.SE_DESELECTION));
-         }
-         MouseDirectManipulation.deselectFrameWidgetsExcept((Frame<?>) parentContainer, except);
+         List<Frame<?>> parentFrames = UiUtils.getParentFrames(parentContainer);
+         if (parentFrames.size() > 1)
+         {
+            // deselect the parent frame if nested, it will deselect parentContainer as well.
+            deselectFrameWidgets(parentFrames.get(1));
+         }
+         else
+         {
+            if (parentContainer != widgetEff)
+            {
+               // then the frame itself
+               BaseConfig fc = parentContainer.config();
+               if (fc.selectable && fc.selected)
+               {
+                  EventManager.postEvent(new DirectManipulationEvent(parentContainer,
+                           parentContainer, Keyboard.SE_DESELECTION));
+               }
+            }
+         }
+
+         deselectFrameWidgets((Frame<?>) parentContainer);
       }
-   }
-   
-   /**
-    * Deselect all selected widget inside the current container, including container itself.
-    * If nested frames deselect parent frame widgets as well. 
-    */
-   private void deselectEverything()
-   {
-      deselectEverythingExcept(null);
-   }
-   
-   /**
-    * Deselect all <p>selectable</p> widgets already <p>selected</p> within a frame.
-    * 
-    * @param frame
-    *        Frame widget.
-    * @param except
-    *        A widget to be skipped by the deselection. This can be {@code null}
-    */
-   private static void deselectFrameWidgetsExcept(Frame<?> frame, Widget<?> except)
-   {
-      Widget<?>[] widLst = frame.getContentPane().widgets();
-
-      for (Widget<?> wid : widLst)
-      {
-         // skip widgets must be excluded
-         if (!wid.isDirectManipulable() || wid == except)
-         { 
-            continue;
-         }
-         
-         BaseConfig bc = wid.config();
-         if (bc.selectable && bc.selected)
-         {
-            EventManager.postEvent(new DirectManipulationEvent(wid, frame,
-                                                               Keyboard.SE_DESELECTION));
-         }
-      }      
-   }
-
-   /**
-    * Deselect all <p>selectable</p> widgets already <p>selected</p> within a frame.
-    * 
-    * @param frame
-    *        Frame widget.
-    *        
-    * FIXME: this private method is never used and should probably be removed.
+
+      EventManager.postEvent(new DirectManipulationEvent(widgetEff, parentContainer, true,
+               Keyboard.SE_SELECTION));
+   }
+   
+   /**
+    * Deselect all <p>selectable</p> widgets already <p>selected</p> within a frame.
+    * 
+    * @param frame
+    *        Frame widget must not be {@code null}
     */
    private static void deselectFrameWidgets(Frame<?> frame)
    {
-      deselectFrameWidgetsExcept(frame, null);
-   }
-   
-   /**
-    * If widget is a nested frame (has a parent frame) deselect all widgets within parent frame.
-    * <p>
-    * Get a list of all parent frames of this frame.
-    * The first element in the list, at index 0, is the frame it self.
-    * If frame is nested it parent frame is located at index 1.
-    * 
-    * @param frame
-    *        Frame widget
-    * @param except
-    *        A widget to be skipped by the deselection. This can be {@code null}
-    */
-   private static void deselectNestedFramesExcept(Frame<?> frame, Widget<?> except)
-   {      
-      List<Frame<?>> parentFrames = UiUtils.getParentFrames(frame);
-      if (parentFrames.size() > 1)
+      for (Widget<?> wid : frame.getContentPane().widgets())
       {
-         MouseDirectManipulation.deselectFrameWidgetsExcept(parentFrames.get(1), except);
+         if (wid.isDirectManipulable())
+         {
+            BaseConfig bc = wid.config();
+            if (bc.selectable && bc.selected)
+            {
+               EventManager.postEvent(
+                        new DirectManipulationEvent(wid, frame, Keyboard.SE_DESELECTION));
+            }
+         }
       }
    }
 
    /**
-    * If widget is a nested frame (has a parent frame) deselect all widgets within parent frame.
-    * <p>
-    * Get a list of all parent frames of this frame.
-    * The first element in the list, at index 0, is the frame it self.
-    * If frame is nested it parent frame is located at index 1.
-    * 
-    * @param frame
-    *        Frame widget
-    *        
-    * FIXME: this private method is never used and should probably be removed.
-    */
-   private static void deselectNestedFrames(Frame<?> frame)
-   {     
-      deselectNestedFramesExcept(frame, null);
-   }
-   
-   /**
     * Collects the widget resize handles bounds for selected resizable widget.
     * 
     * @param    widResize
@@ -1544,45 +1500,46 @@
     * 
     * @return   Array of the {@link Widget} elements to be moved.
     */
-   private Widget<?>[] getWidgetsToMove()
+   private final Widget<?>[] getWidgetsToMove()
    {
+      if (parentContainer == null)
+      {
+         return new Widget<?>[0];
+      }
+
       ArrayList<Widget<?>> res = new ArrayList<Widget<?>>();
-      if (parentContainer != null)
-      {
-         // check first the frame itself if we are looking from window widget perspective
-         if (isWindow || isFrame)
-         {
-            BaseConfig fc = parentContainer.config();
-            if (fc.selected && fc.movable)
-            {
-               // add frame widget to move
-               res.add(parentContainer);
-            }
-         }
-
-         // when moving frame or window do not include the child widgets
-         if (!isWindow && !isFrame)
-         {
-            // enumerate all other widgets
-            Widget<?>[] widLst = ((Frame) parentContainer).getContentPane().widgets();
-            for (Widget<?> wid : widLst)
-            {
-               // skip widgets must be excluded
-               if (!wid.isDirectManipulable())
-               {
-                  continue;
-               }
-
-               BaseConfig bc = wid.config();
-               if (bc.selected && bc.movable)
-               {
-                  // add another widget to move
-                  res.add(wid);
-               }
-            }
-         }
-      }
-      
+      // check first the frame itself if we are looking from window widget perspective
+      if (isWindow || isFrame)
+      {
+         BaseConfig fc = parentContainer.config();
+         if (fc.selected && fc.movable)
+         {
+            // add frame widget to move
+            res.add(parentContainer);
+         }
+      }
+
+      // when moving frame or window do not include the child widgets
+      if (!isWindow && !isFrame)
+      {
+         // enumerate all other widgets
+         for (Widget<?> wid : ((Frame) parentContainer).getContentPane().widgets())
+         {
+            // skip widgets must be excluded
+            if (!wid.isDirectManipulable())
+            {
+               continue;
+            }
+
+            BaseConfig bc = wid.config();
+            if (bc.selected && bc.movable)
+            {
+               // add another widget to move
+               res.add(wid);
+            }
+         }
+      }
+
       return res.toArray(new Widget<?>[res.size()]);
    }
    

